> For the complete documentation index, see [llms.txt](https://docs.macilib.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.macilib.org/docs/tools/format-functions/maci.cleanformat.md).

# maci.cleanformat

Formats and dumps dictionaries, lists, tuples, and sets to a string formatted in a clean human-readable structure. Useful for nested data to be represented over multiple lines with indentation.

{% hint style="info" %}
maci.cleanformat  ->  str
{% endhint %}

*Basic Example of formatting data to a string using default positional parameter*

```python
data = maci.cleanformat(nested_data)
```

In this example, we simply format nested data to a string using the cleanformat function and pass the data as an argument to the function, and assign the returned string data to a variable. <br>

*Example output using cleanformat with nested dictionary data*

```python
{
    'k1': 'value1',
    'k2': {
        'sub1': 'sub_value1',
        'sub2': {
            'sub_sub1': 'sub_sub_value1',
        },
        'sub3': 'sub_value3',
    },
    'k3': 'value3',
}
```

*Example output using cleanformat with nested list data*

```python
[
    1,
    [
        1,
        2,
        [
            1,
            2,
            3,
        ],
        3,
    ],
    2,
    3,
]
```

### parameters & arguments

Describes all parameter functionality and accepted data types

<details>

<summary>data:  dict | list | tuple | set</summary>

First and only required positional argument. Accepts dictionaries, lists, tuples, and sets

Use this parameter to pass in the data you want to format

</details>

<details>

<summary>indent_level:  int</summary>

Optional parameter. Accepts integers. Default = 1

Use this parameter to change the indentation level for structured data (lists, dicts, tuples, sets) in the output. Indentation will be applied to nested data.

Default uses the standard 4x spaces indentation practice. A single integer represents adding 4x more spaces at each level. For example 1 = 4x spaces, 2 = 8x spaces, 3 = 12x spaces, etc.

Note: Setting it to 0 will slightly improve write performance by approx 5%.

</details>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.macilib.org/docs/tools/format-functions/maci.cleanformat.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
